/*************        CONNECTED   COMPONENTS       ***************/
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define NS 10
#define NA 8
#define YES  1
#define NO 0

struct p { int n; struct p * s;};
struct p * first[NS], * last[NS];
int out[NS];
int e1[NA],e2[NA]; int x[NS],y[NS];
int searchwhere(int vertex);
void pause(void);
void putpixel(int xe, int ye, Uint32 c);
Uint32 getpixel(int xe, int ye);
void circle( int xo, int yo, int R, Uint32 c);
void filldisc(int xo, int yo, int R,Uint32 c);
void line(int x0,int y0, int x1,int y1, Uint32 c);
void linewithwidth(int x1, int y1, int x2, int y2, int epaisseur,Uint32 c);
SDL_Surface * screen; Uint32 white, color[6];
SDL_Surface *texte;  SDL_Rect position;TTF_Font *police=NULL;char chiffre[2000];

int main(int argc, char ** argv)
{  int i,a,b,j; struct p * ptr;

   SDL_Init(SDL_INIT_VIDEO);
   screen=SDL_SetVideoMode(800,600,32, SDL_HWSURFACE|SDL_DOUBLEBUF);
   white=SDL_MapRGB(screen->format,255,255,255);
   color[0]=SDL_MapRGB(screen->format,0,0,0);
   color[1]=SDL_MapRGB(screen->format,255,0,0);
   color[2]=SDL_MapRGB(screen->format,0,255,0);
   color[3]=SDL_MapRGB(screen->format,0,0,250);
   color[4]=SDL_MapRGB(screen->format,255,255,0);
   color[5]=SDL_MapRGB(screen->format,200,200,200);
   SDL_FillRect(screen,0,white);
   TTF_Init();
   police=TTF_OpenFont("times.ttf",20);
    SDL_Color cnoire={0,0,0};


x[0]= 20;y[0]=20;   x[1]=80;y[1]=20;  x[5]=140;y[5]=20;   x[2]=200;y[2]=20;
x[6]=80;y[6]=120;  x[9]=140;y[9]=120;  x[3]=200;y[3]=120;  x[7]=260;y[7]=120;
x[4]=320;y[4]=20;  x[8]=320;y[8]=120;

e1[0]=1;e2[0]=6;  e1[1]=4;e2[1]=8;  e1[2]=5;e2[2]=9;  e1[3]=2;e2[3]=3;
e1[4]=1;e2[4]=5;  e1[5]=2;e2[5]=7;  e1[6]=3;e2[6]=7;  e1[7]=5;e2[7]=6;

for(i=0;i<NS;i++)
{filldisc(x[i],y[i],3,color[0]);
  sprintf( chiffre," %d",i);
    texte=TTF_RenderText_Solid(police,chiffre,cnoire);
    position.x=x[i]-20;position.y=y[i]-20;
    SDL_BlitSurface(texte,NULL,screen,&position);
}
for(i=0;i<NA;i++)  line(x[e1[i]],y[e1[i]],x[e2[i]],y[e2[i]],color[0]);
SDL_Flip(screen);  pause();

for(i=0;i<NS;i++) out[i]=NO;

for(i=0;i<NS;i++)
 { first[i]=(struct p *) malloc(sizeof(struct p));
    first[i]->n=i;  first[i]->s=NULL;  last[i]=first[i];
 }
for(i=0;i<NA;i++)
   { a=searchwhere(e1[i]);b=searchwhere(e2[i]);
      if (a!=b)
        { last[a]->s=first[b];  out[b]=YES;  last[a]=last[b];
           linewithwidth(x[a],y[a],x[b],y[b],2,color[1]);
           SDL_Flip(screen);  pause();
        }
   }
 for(j=0;j<NS;j++) if (out[j]==NO)
   { ptr=first[j];
     do
       { filldisc(x[ptr->n],y[ptr->n],7,color[j+1]);
          ptr=ptr->s;
       }
     while (ptr!=NULL);
   }
 SDL_Flip(screen);  pause();TTF_CloseFont(police); TTF_Quit();  return 0;
}

int searchwhere(int vertex)
{ int i; struct p * ptr;
for(i=0;i<NS;i++)  if (out[i]==NO)
  { ptr=first[i];
     do { if (ptr->n==vertex) return i;    ptr=ptr->s; }
    while(ptr!=NULL);
  }
}

void pause(void)
{
    SDL_Event evenement;
    do   SDL_WaitEvent(&evenement);
    while(evenement.type != SDL_QUIT && evenement.type != SDL_KEYDOWN);
}

void putpixel(int xe, int ye, Uint32 c)
{ Uint32 * numerocase;
numerocase= (Uint32 *)(screen->pixels)+xe+ye*screen->w;    *numerocase=c;
}

Uint32 getpixel(int xe, int ye)
{ Uint32 * numerocase;
   numerocase= (Uint32 *)(screen->pixels)+xe+ye*screen->w;   return (*numerocase);
}


void linewithwidth(int x1, int y1, int x2, int y2, int epaisseur,Uint32 c)
{
int dx,dy;
float k,xf1,yf1,xf2,yf2,d,dx1,dy1,ndx1,ndy1,ndx2,ndy2,angle=M_PI/2.;
line(x1,y1,x2,y2,c);
dx=x2-x1; dy=y2-y1;       d=sqrt(dx*dx+dy*dy);
if (d!=0.)      /* si le vecteur n’est pas nul */
{ dx1=(float)epaisseur*(float)dx/d; dy1=(float)epaisseur*(float)dy/d;
   ndx1=dx1*cos(angle)-dy1*sin(angle);
   ndy1=dx1*sin(angle)+dy1*cos(angle);
   ndx2=dx1*cos(-angle)-dy1*sin(-angle);
   ndy2=dx1*sin(-angle)+dy1*cos(-angle);
   for(k=0;k<=1.;k+=0.1/d)
   {
   xf1=(1.-k)*x1+k*x2; yf1=(1.-k)*y1+k*y2;
   xf2=xf1-ndx1; yf2=yf1-ndy1;  line(xf1,yf1,xf2,yf2,c);
   xf2=xf1-ndx2; yf2=yf1-ndy2;    line(xf1,yf1,xf2,yf2,c);
   }
}
}

void circle( int xo, int yo, int R, Uint32 c)
  {
      int x, y, F, F1, F2,newx,newy;
      x=xo; y=yo+R; F=0;
      if (x<800 && x>=0 && y>=0 && y<600) putpixel(x,y,c);
      if (x<800 && x>=0 && 2*yo-y>=0 && 2*yo-y<600) putpixel (x,2*yo-y, c);
      while( y>yo)
         {
             F1=F+2*(x-xo)+1; F2=F-2*(y-yo)+1;
             if ( abs(F1)<abs(F2))  { x+=1; F=F1;}
             else {y-=1; F=F2;}
             if (x<800 && x>=0 && y>=0 && y<600) putpixel(x,y,c);
              newx=2*xo-x ; newy=2*yo-y ;
             if (x<800 && x>=0 && newy>=0 && newy<600) putpixel(x, newy,c);
             if (newx<800 && newx>=0 && y>=0 && y<600) putpixel( newx,y,c);
             if (newx<800 && newx>=0 && newy>=0 && newy<600) putpixel(newx,
             newy, c);
         }
       if (xo+R<800 && xo+R>=0 && yo>=0 && yo<600) putpixel(xo+R,yo,c);
       if (xo-R<800 && xo-R>=0 && yo>=0 && yo<600) putpixel(xo-R,yo, c);
  }

void filldisc( int xo, int yo, int R, Uint32 c)
  {
      int x, y, F, F1, F2,newx,newy,xx;
      x=xo; y=yo+R; F=0;
      if (x<800 && x>=0 && y>=0 && y<600) putpixel(x,y,c);
      if (x<800 && x>=0 && 2*yo-y>=0 && 2*yo-y<600) putpixel (x,2*yo-y, c);
      while( y>yo)
         {
             F1=F+2*(x-xo)+1; F2=F-2*(y-yo)+1;
             if ( abs(F1)<abs(F2))  { x+=1; F=F1;}
             else {y-=1; F=F2;}
             newx=2*xo-x ; newy=2*yo-y ;
             for(xx=newx; xx<=x; xx++)if (xx<800 && xx>=0 && y>=0 && y<600 )
             putpixel(xx,y,c);
             for(xx=newx; xx<=x; xx++)if (xx<800 && xx>=0 && newy>=0 && newy<600 )
             putpixel(xx,newy,c);
         }
       if (xo+R<800 && xo+R>=0&& y>=0 && y<600) putpixel(xo+R,yo,c);
       if (xo-R<800 && xo-R>=0&& y>=0 && y<600) putpixel(xo-R,yo, c);
  }
/**  ligne en marches d'escalier */
void line(int x0,int y0, int x1,int y1, Uint32 c)
{
int dx,dy,x,y,residu,absdx,absdy,pasx,pasy,i;
dx=x1-x0; dy=y1-y0;  residu=0;       x=x0;y=y0;  if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
if (dx>0) pasx=1;else pasx=-1; if (dy>0) pasy=1; else pasy=-1;
absdx=abs(dx);absdy=abs(dy);
if (dx==0) for(i=0;i<absdy;i++) { y+=pasy;
                                                    if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c); }
else if(dy==0) for(i=0;i<absdx;i++){ x+=pasx;
                                                         if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);  }
else if (absdx==absdy)
   for(i=0;i<absdx;i++) {x+=pasx; if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
                                     y+=pasy;
                                     if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
                                     }
else if (absdx>absdy)
          for(i=0;i<absdx;i++)
			  { x+=pasx; if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
			     residu+=absdy;
			     if(residu >= absdx) {residu -=absdx; y+=pasy;
	                              		        if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
			                                    }
			  }
else for(i=0;i<absdy;i++)
             {y+=pasy; if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
               residu +=absdx;
              if (residu>=absdy)   {residu -= absdy;x +=pasx;
                                              if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
                                             }
             }
}

