/***************           KRUSKAL   ALGORITHM            *****************/
#include <SDL/SDL.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#define NS 500    /* B*(H+1) */
#define YES 1
#define NO 0
#define B 25
#define H 19
#define zoom 25.

int search(int vertex);
int finished(void);
void pause(void);
void putpixel(int xe, int ye, Uint32 c);
Uint32 getpixel(int xe, int ye);
void circle( int xo, int yo, int R, Uint32 c);
void filldisc(int xo, int yo, int R,Uint32 c);
void line(int x0,int y0, int x1,int y1, Uint32 c);
void linewithwidth(int x1, int y1, int x2, int y2, int epaisseur,Uint32 c);
int xorig=10,yorig=10;
struct p { int n; struct p * s;};
struct p * start[NS], * last[NS];
int out[NS],x[NS],y[NS],NA;
int e1[3000],e2[3000],aux,l[3000],edge1[3000],edge2[3000];
SDL_Surface * screen; Uint32 white,black,red,green,blue;


int main(int argc, char ** argv)
{  int i,a,b,j,k;  int n;
   SDL_Init(SDL_INIT_VIDEO);srand(time(NULL));
   screen=SDL_SetVideoMode(800,600,32, SDL_HWSURFACE|SDL_DOUBLEBUF);
   white=SDL_MapRGB(screen->format,255,255,255);
   black=SDL_MapRGB(screen->format,0,0,0);
   red=SDL_MapRGB(screen->format,255,0,0);
   green=SDL_MapRGB(screen->format,0,255,0);
   blue=SDL_MapRGB(screen->format,0,0,255);
   SDL_FillRect(screen,0,white);
/**  vertices  */
for(i=0;i<B*(H+1);i++)  {x[i]=xorig+zoom*(i%B); y[i]=yorig+zoom*(i/B);}
for(i=0;i<B*(H+1);i++) circle(x[i],y[i],3,black);

/**   NA  edges with weight  */
NA=0;
for(k=0;k<NS/2;k++)
{  n=rand()%(B*(H+1));
    if ((n+1)%B!=0 && getpixel(x[n],y[n])==white)
       {e1[NA]=n;e2[NA]=n+1;  line(x[n],y[n],x[n+1],y[n+1],black);   NA++;}
}

for(k=0;k<NS/2;k++)
{ n=rand()%(B*H);
  if (getpixel(x[n],y[n])!=red)
    {e1[NA]=n;e2[NA]=n+B;
     line(x[n],y[n],x[n+B],y[n+B],black); putpixel(x[n],y[n],red); NA++; }
}

for(k=0;k<NS;k++)
{
n=rand()%(B*H);
if ((n+1)%B!=0 && getpixel(x[n],y[n])!=green)
 {e1[NA]=n;e2[NA]=n+B+1;
  line(x[n],y[n],x[n+B+1],y[n+B+1],black);putpixel(x[n],y[n],green);   NA++;
 }
}

for(k=0;k<NS;k++)
{n=rand()%(B*H);
  if ((n+1)%B!=0 && (n+2)%B!=0 && getpixel(x[n],y[n])!=blue)
     {e1[NA]=n;e2[NA]=n+B+2;
       putpixel(x[n],y[n],blue); line(x[n],y[n],x[n+B+2],y[n+B+2],black);  NA++; }
}

for(k=0;k<NS;k++)
{
n=rand()%(B*H);
if (n%B!=0 && getpixel(x[n],y[n])!=red)
   {e1[NA]=n;e2[NA]=n+B-1;
   line(x[n],y[n],x[n+B-1],y[n+B-1],black);putpixel(x[n],y[n],red); NA++;
   }
}

for(k=0;k<NS;k++)
{ n=rand()%(B*H);
  if (n%B!=0 && n%B!=1 && getpixel(x[n],y[n])!=red)
     {e1[NA]=n;e2[NA]=n+B-1;
       line(x[n],y[n],x[n+B-2],y[n+B-2],black);putpixel(x[n],y[n],red);     NA++;}
}
SDL_Flip(screen); pause();

/** weight = distance  */
for(i=0;i<NA;i++) l[i]=abs(x[e2[i]]-x[e1[i]])+abs(y[e2[i]]-y[e1[i]]);

/**  sort of edges according their weight  */
for(i=0;i<NA-1;i++)  for(j=i+1;j<NA;j++)  if (l[i]>l[j])
  { aux=l[i];l[i]=l[j];l[j]=aux;
    aux=e1[i];e1[i]=e1[j];e1[j]=aux;
    aux=e2[i];e2[i]=e2[j];e2[j]=aux;
  }

for(i=0;i<NS;i++) out[i]=NO;
for(i=0;i<NS;i++)
 {
 start[i]=(struct p *) malloc(sizeof(struct p));
 start[i]->n=i;  start[i]->s=NULL;
 last[i]=start[i];
 }
k=0;
for(i=0;i<NA;i++)
 { a=search(e1[i]); b=search(e2[i]);
    if (a!=b)
      { last[a]->s=start[b];  out[b]=YES;  last[a]=last[b];
         edge1[k]=e1[i]; edge2[k]=e2[i];  k++;
      }
    if (finished()==YES) break;
 }
/** drawing of the tree */
for(j=0;j<k;j++) linewithwidth(x[edge1[j]],y[edge1[j]],x[edge2[j]],y[edge2[j]],1,red);
SDL_Flip(screen); pause();
for(i=0;i<790;i++) for(j=0;j<580;j++)  if (getpixel(i,j)!=red) putpixel(i,j,white);
for(i=0;i<B*(H+1);i++) circle(x[i],y[i],3,black);
SDL_Flip(screen); pause(); return 0;
}

int search(int vertex)
{
int i; struct p * ptr;

for(i=0;i<NS;i++)
if (out[i]==NO)
{
ptr=start[i];
do
{
if (ptr->n==vertex) return i;
ptr=ptr->s;
}
while(ptr!=NULL);
}
}

int finished(void)
{
int i,compteur;

compteur=0;
for(i=0;i<NS;i++) if (out[i]==NO) compteur++;
if (compteur==1) return YES;
else return NO;
}

void pause(void)
{
    SDL_Event evenement;
    do   SDL_WaitEvent(&evenement);
    while(evenement.type != SDL_QUIT && evenement.type != SDL_KEYDOWN);
}

void putpixel(int xe, int ye, Uint32 c)
{ Uint32 * numerocase;
numerocase= (Uint32 *)(screen->pixels)+xe+ye*screen->w;    *numerocase=c;
}

Uint32 getpixel(int xe, int ye)
{ Uint32 * numerocase;
   numerocase= (Uint32 *)(screen->pixels)+xe+ye*screen->w;   return (*numerocase);
}

void linewithwidth(int x1, int y1, int x2, int y2, int epaisseur,Uint32 c)
{
int dx,dy;
float k,xf1,yf1,xf2,yf2,d,dx1,dy1,ndx1,ndy1,ndx2,ndy2,angle=M_PI/2.;
line(x1,y1,x2,y2,c);
dx=x2-x1; dy=y2-y1;       d=sqrt(dx*dx+dy*dy);
if (d!=0.)      /* si le vecteur n’est pas nul */
{ dx1=(float)epaisseur*(float)dx/d; dy1=(float)epaisseur*(float)dy/d;
   ndx1=dx1*cos(angle)-dy1*sin(angle);
   ndy1=dx1*sin(angle)+dy1*cos(angle);
   ndx2=dx1*cos(-angle)-dy1*sin(-angle);
   ndy2=dx1*sin(-angle)+dy1*cos(-angle);
   for(k=0;k<=1.;k+=0.1/d)
   {
   xf1=(1.-k)*x1+k*x2; yf1=(1.-k)*y1+k*y2;
   xf2=xf1-ndx1; yf2=yf1-ndy1;  line(xf1,yf1,xf2,yf2,c);
   xf2=xf1-ndx2; yf2=yf1-ndy2;    line(xf1,yf1,xf2,yf2,c);
   }
}
}

void circle( int xo, int yo, int R, Uint32 c)
  {
      int x, y, F, F1, F2,newx,newy;
      x=xo; y=yo+R; F=0;
      if (x<800 && x>=0 && y>=0 && y<600) putpixel(x,y,c);
      if (x<800 && x>=0 && 2*yo-y>=0 && 2*yo-y<600) putpixel (x,2*yo-y, c);
      while( y>yo)
         {
             F1=F+2*(x-xo)+1; F2=F-2*(y-yo)+1;
             if ( abs(F1)<abs(F2))  { x+=1; F=F1;}
             else {y-=1; F=F2;}
             if (x<800 && x>=0 && y>=0 && y<600) putpixel(x,y,c);
              newx=2*xo-x ; newy=2*yo-y ;
             if (x<800 && x>=0 && newy>=0 && newy<600) putpixel(x, newy,c);
             if (newx<800 && newx>=0 && y>=0 && y<600) putpixel( newx,y,c);
             if (newx<800 && newx>=0 && newy>=0 && newy<600) putpixel(newx,
             newy, c);
         }
       if (xo+R<800 && xo+R>=0 && yo>=0 && yo<600) putpixel(xo+R,yo,c);
       if (xo-R<800 && xo-R>=0 && yo>=0 && yo<600) putpixel(xo-R,yo, c);
  }

void filldisc( int xo, int yo, int R, Uint32 c)
  {
      int x, y, F, F1, F2,newx,newy,xx;
      x=xo; y=yo+R; F=0;
      if (x<800 && x>=0 && y>=0 && y<600) putpixel(x,y,c);
      if (x<800 && x>=0 && 2*yo-y>=0 && 2*yo-y<600) putpixel (x,2*yo-y, c);
      while( y>yo)
         {
             F1=F+2*(x-xo)+1; F2=F-2*(y-yo)+1;
             if ( abs(F1)<abs(F2))  { x+=1; F=F1;}
             else {y-=1; F=F2;}
             newx=2*xo-x ; newy=2*yo-y ;
             for(xx=newx; xx<=x; xx++)if (xx<800 && xx>=0 && y>=0 && y<600 )
             putpixel(xx,y,c);
             for(xx=newx; xx<=x; xx++)if (xx<800 && xx>=0 && newy>=0 && newy<600 )
             putpixel(xx,newy,c);
         }
       if (xo+R<800 && xo+R>=0&& y>=0 && y<600) putpixel(xo+R,yo,c);
       if (xo-R<800 && xo-R>=0&& y>=0 && y<600) putpixel(xo-R,yo, c);
  }
/**  ligne en marches d'escalier */
void line(int x0,int y0, int x1,int y1, Uint32 c)
{
int dx,dy,x,y,residu,absdx,absdy,pasx,pasy,i;
dx=x1-x0; dy=y1-y0;  residu=0;       x=x0;y=y0;  if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
if (dx>0) pasx=1;else pasx=-1; if (dy>0) pasy=1; else pasy=-1;
absdx=abs(dx);absdy=abs(dy);
if (dx==0) for(i=0;i<absdy;i++) { y+=pasy;
                                                    if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c); }
else if(dy==0) for(i=0;i<absdx;i++){ x+=pasx;
                                                         if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);  }
else if (absdx==absdy)
   for(i=0;i<absdx;i++) {x+=pasx; if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
                                     y+=pasy;
                                     if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
                                     }
else if (absdx>absdy)
          for(i=0;i<absdx;i++)
			  { x+=pasx; if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
			     residu+=absdy;
			     if(residu >= absdx) {residu -=absdx; y+=pasy;
	                              		        if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
			                                    }
			  }
else for(i=0;i<absdy;i++)
             {y+=pasy; if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
               residu +=absdx;
              if (residu>=absdy)   {residu -= absdy;x +=pasx;
                                              if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
                                             }
             }
}

